/**
 * @file 基于 react-datetime 改造。
 */
import ReactDatePicker from 'react-datetime';
import React from 'react';
import moment from 'moment';
export declare type DateType = 'year' | 'month' | 'date' | 'hours' | 'minutes' | 'seconds';
export interface BoundaryObject {
    max: number;
    min: number;
}
export interface DateBoundary {
    year: BoundaryObject;
    month: BoundaryObject;
    date: BoundaryObject;
    hours: BoundaryObject;
    minutes: BoundaryObject;
    seconds: BoundaryObject;
}
interface BaseDatePickerProps extends Omit<ReactDatePicker.DatetimepickerProps, 'viewMode'> {
    viewMode?: 'years' | 'months' | 'days' | 'time' | 'quarters';
    inputFormat?: string;
    onViewModeChange?: (type: string) => void;
    requiredConfirm?: boolean;
    onClose?: () => void;
    isEndDate?: boolean;
    minDate?: moment.Moment;
    maxDate?: moment.Moment;
    renderDay?: (props: any, currentDate: moment.Moment, selectedDate: moment.Moment) => JSX.Element;
    renderQuarter?: (props: any, quartar: number, year?: number, date?: moment.Moment) => JSX.Element;
    schedules?: Array<{
        startTime: Date;
        endTime: Date;
        content: string | React.ReactElement;
        color?: string;
    }>;
    largeMode?: boolean;
    onScheduleClick?: (scheduleData: any) => void;
    hideHeader?: boolean;
    updateOn?: string;
    useMobileUI?: boolean;
    embed?: boolean;
    showToolbar?: boolean;
}
declare const _default: React.ComponentType<BaseDatePickerProps>;
export default _default;
